#define NDEBUG

#include <cstdio>
#include <cstdlib>
#include <cstring>

#include <sdsl/suffixarrays.hpp>
#include <sdsl/util.hpp>
#include <sdsl/testutils.hpp>
#include "readfile.h"

using namespace sdsl;

char filename_bw[1024];
char filename_lst[1024];

int main(int argc, char **argv) {
	if (argc!=3) {
		fprintf(stderr, "usage: %s inputfile outputfile\n", argv[0]);
		exit(1);
	}
	printf("Reading files...\n");

	uint32_t n, dummy;
	strcpy(filename_bw, argv[1]);
	strcat(filename_bw, ".bw");
	const char* bw = readfile(filename_bw, n);

	strcpy(filename_lst, argv[1]);
	strcat(filename_lst, ".lst");
	FILE *fp = fopen(filename_lst,"r");
	ulong last;
	if (fp == NULL) 
	{
		printf("Error while reading inputfile 2.\n");
		exit(1);
	}
	rewind (fp); // just to be sure
	dummy = fscanf(fp,"%lu", &last);
	fclose(fp);

	printf("Converting...\n");
	int_vector<8> bwt(n+1);	
	for(uint32_t i=0, j=0; i<=n; i++)
	{
		if(!bw[j])
		{
			printf("Error: 0-character in input. Can't convert!\n");			
			exit(1);
		}
		if(i == last)
		{
			bwt[i] = 0;
		}
		else
		{
			bwt[i] = bw[j++];
		}
	}
	printf("Writing ...\n");
	last = util::store_to_file(bwt, argv[2]);

	printf("Done.\n");
	return 0;
}
