/* sdsl - succinct data structures library
    Copyright (C) 2010 Simon Gog 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/ .
*/
/*! \file lcp_putu.hpp
    \brief lcp_putu.hpp contains an implementation of a compressed lcp array. The basic idea is from Simon Puglisi and Andrew Turpin (ISAAC 2008) 
	\author Simon Gog
*/
#ifndef INCLUDED_SDSL_LCP_PUTU
#define INCLUDED_SDSL_LCP_PUTU

#include "lcp.hpp"
#include "int_vector.hpp"

template<class Csa = csa_sada<> >
class lcp_putu{
	public:


	typedef lcp_permuted_tag								 lcp_category; // as the samples are permuted
	
	enum{	fast_access = 0,
		 	text_order  = 1,
			sa_order	= 1};

};


#endif
