#include <sdsl/suffixarrays.hpp>

using namespace sdsl;
using namespace std;

typedef bit_vector::size_type size_type;

int main(int argc, char **argv)
{
	stop_watch sw;
	sw.start();

	// Init to create
	tMSS file_map;
	string dir = "";
	string id = "";
	if(argc==4)
	{
		file_map["text"] = argv[1];
		file_map["sa"] = argv[2];
		id = argv[3];
	}
	else
	{
		cout << "Program takes path of text, path of suffix array and a FILENAME. It creates the BWT." << endl;
		cout << "\tPath to text" << endl;
		cout << "\tPath to suffix array" << endl;
		cout << "\tFILENAME" << endl;
		cout << endl;
		cout << "\tOutputfile: bwt_FILENAME" << endl;
		return 1;
	}

	// Create BWT
	construct_bwt(file_map, dir, id);

	sw.stop();
	fprintf(stderr, "%llu\n", sw.get_abs_user_time() + sw.get_abs_sys_time());
	return 0;
}
