#include <sdsl/lcp_construct.hpp>

using namespace sdsl;
using namespace std;

int main(int argc, char **argv)
{
	// Init
	typedef bit_vector::size_type size_type;
	tMSS file_map;
	
	string dir = "";
	string id = "";

	if(argc==4)
	{
		file_map["text"] = argv[1];
		file_map["sa"] = argv[2];
		id = argv[3];
		construct_bwt(file_map, dir, id);
	}
	else if(argc==5)
	{
		file_map["text"] = argv[1];
		file_map["sa"] = argv[2];
		file_map["bwt"] = argv[3];
		id = argv[4];
	}
	else
	{
		cout << "Program takes path of text, path of suffix array, path of BWT and a FILENAME. It creates the LCP array." << endl;
		cout << "\tPath to text" << endl;
		cout << "\tPath to suffix array" << endl;
		cout << "\tPath to BWT" << endl;
		cout << "\tFILENAME" << endl;
		cout << endl;
		cout << "\tOutputfile: lcp_FILENAME" << endl;
		cout << "============== Alternative ==============" << endl;
		cout << "Program takes path of text, path of suffix array and a FILENAME. It creates the BWT and LCP array." << endl;
		cout << "\tPath to text" << endl;
		cout << "\tPath to suffix array" << endl;
		cout << "\tFILENAME" << endl;
		cout << endl;
		cout << "\tOutputfile: bwt_FILENAME" << endl;
		cout << "\tOutputfile: lcp_FILENAME" << endl;
		return 1;
	}

	// Create LCP
	construct_lcp_goPHI(file_map, dir, id);

	return 0;
}
