#include <sdsl/int_vector.hpp>
#include <sdsl/util.hpp>

using namespace sdsl;
using namespace std;

typedef bit_vector::size_type size_type;

int main(int argc, char **argv)
{
	// Check input
	if(argc!=2)
	{
		cerr << "Need one parameter: File to lcp array" << endl;
		return 0;
	}

	// Parameter
	size_type buffer_size = 10000000;

	// Read file
	string input_filename = argv[1];
	int_vector_file_buffer<> input_buffer(input_filename.c_str(), buffer_size);

	// Get length
	input_buffer.reset();
	size_type input_length = input_buffer.int_vector_size;

	// Display file
	for(size_type i=0, r_sum=0, r=0; r_sum < input_length; )
	{
		// Display next r values
		for( ; i < r_sum+r; ++i)
		{
			cout << input_buffer[i-r_sum] << endl;
		}

		// Prepare buffer
		r_sum += r;
		r = input_buffer.load_next_block();
	}
	
	// Finished
	return 0;
}
